function openCalendar(input)
{
    var url = "/fbi/lightsquid-calendar.html";
    if(input != ' ')
	url = url + "?input=" + input;
    calWindow = window.open(url, "calendar", "status=0,toolbar=0,location=0,menubar=0,resizeable=0,scrollbars=0,width=250,height=200,top=100,left=100");
    calWindow.focus();
}

var selectedDate = 0;
var curDate = 0;
var elid = 0;
var retid = 0;

function insertDate(obj)
{
	var month = curDate.getMonth();
	var year = curDate.getFullYear();
	var day = nodeText(obj);

	selectedDate = new Date(year,month,day);
	buildCalendar();

	if (++month < 10)
		month = "0" + month;
	
	if (day < 10)
		day = "0" + day;

	retid.value = year + "-" + month + "-" + day;
	window.close();
}

function prevMonth (a)
{
	curDate.setMonth(curDate.getMonth()-1);
	buildCalendar();
}

function nextMonth ()
{
	curDate.setMonth(curDate.getMonth()+1);
	buildCalendar();
}

function buildCalendar ()
{
	if (!elid) return;

	var monthList = [
		{ name: _( "January"),   days: 31 },
		{ name: _( "February"),  days: -1 },
		{ name: _( "March"),     days: 31 },
		{ name: _( "April"),     days: 30 },
		{ name: _( "May"),       days: 31 },
		{ name: _( "June"),      days: 30 },
		{ name: _( "July"),      days: 31 },
		{ name: _( "August"),    days: 31 },
		{ name: _( "September"), days: 30 },
		{ name: _( "October"),   days: 31 },
		{ name: _("November"),  days: 30 },
		{ name: _("December"),  days: 31 }
	];

	var weekList = [  _("Mo"), _("Tu"), _("We"), _("Th"), _("Fr"), _("Sa"), _("Su") ];

	var Month = curDate.getMonth();
	var Year = curDate.getFullYear();
	var weekDay = curDate.getDay() + 0; // 0 for Sunday, 1 for Monday

	var today = 0;

	if ( selectedDate && Year == selectedDate.getFullYear() && Month == selectedDate.getMonth() )
		today = selectedDate.getDate();

	monthList[1].days = ( ((Year%100 != 0) && (Year%4 == 0)) || (Year%400 == 0) ) ? 29 : 28;

	var out = "";
	out += '   <table id="calendar-table" cols="7">';
	out += '      <tr align="center">';
	out += '         <td id="calendar-header"><div class="btn" onclick="prevMonth();">&lt;</div></td>';
	out += '         <td id="calendar-header" colspan="5" align="center">';
	out +=              monthList[Month].name + ' <span id="year">' + Year + "</span>";
	out += '         </td>';
	out += '         <td id="calendar-header"><div class="btn" onclick="nextMonth();">&gt;</div></td>';
	out += '      </tr>';

	// Add weeks header line
	out += '      <tr align="center">';
	for (var i = 0; i < 7; i++)
		out += '<td class="week">' + weekList[i] + '</td>';
	out += '      </tr>';

	// Build days
	out += '      <tr align="center">';

	for (var i = 1; i <= 42; i++) {
		var day = "&nbsp;";
		var x = i - weekDay;
		
		if ( (x >= 0) && (x < monthList[Month].days) )
			day = x + 1;

		var dayClass = "day";

		if ( day == today )
			dayClass = "today";

		out += '<td class="' + dayClass + '" onclick="insertDate(this);">';
		out += day;
		out += '</td>';
		
		if( (i%7 == 0) && (i < 36) )
			out += '</tr><tr align="center">';
	}
	out += '</tr></table>';

	elid.innerHTML = out;
}

function makeDate(txt)
{
    var values = txt.split('-');
    if (values.length != 3) {
	var now = new Date();
	now.setDate(1);
	return [ new Date() , now ];
    }
    else
	return [ new Date(values[0],values[1]-1,values[2]),
		 new Date(values[0],values[1]-1,1) ];
}

function initCalendar()
{
    	elid = document.getElementById("calendar");
	if (!elid) return;

	var input = document.location.search.match(/^\?input=(\w+)/)[1];
	retid = opener.document.getElementById(input);
	
	var dates = makeDate(retid.value);
	selectedDate = dates[0];
	curDate = dates[1];

	buildCalendar();
}
